SystemOrganization addCategory: #'BlackBoxParser-Expression'!
SystemOrganization addCategory: #'BlackBoxParser-test'!
SystemOrganization addCategory: #BlackBoxParser!

TestCase subclass: #BBParserStackTest
	instanceVariableNames: 'parser expectedRpnCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

BBParserStackTest subclass: #BBP12Plus34Div56Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:14'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: nil equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:15'!
testStep1

	parser sourceString: '('.
	parser run.
	self assert: (BBParenthesis new) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:30'!
testStep2

	parser sourceString: '(1'.
	parser run.
	self assert: (BBParenthesis inner: (BBNumber number: 1)) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:31'!
testStep25

	parser sourceString: '(12'.
	parser run.
	self assert: (BBParenthesis inner: (BBNumber number: 12)) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:32'!
testStep3

	parser sourceString: '(12+'.
	parser run.
	self assert: (BBParenthesis inner: (BBAdd new left: (BBNumber number: 12))) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:33'!
testStep4

	parser sourceString: '(12+3'.
	parser run.
	self assert: (BBParenthesis inner: (BBAdd left: (BBNumber number: 12) right: (BBNumber number: 3))) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:34'!
testStep5

	parser sourceString: '(12+34'.
	parser run.
	self assert: (BBParenthesis inner: (BBAdd left: (BBNumber number: 12) right: (BBNumber number: 34))) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:15'!
testStep6

	parser sourceString: '(12+34)'.
	parser run.
	self assert: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34))) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:16'!
testStep7

	parser sourceString: '(12+34)/'.
	parser run.
	self assert: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34)))) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:16'!
testStep8

	parser sourceString: '(12+34)/5'.
	parser run.
	self assert: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34))); right: (BBNumber new number: 5)) equals: parser expression.! !

!BBP12Plus34Div56Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:17'!
testStep9

	parser sourceString: '(12+34)/56'.
	parser run.
	self assert: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 12); right: (BBNumber new number: 34))); right: (BBNumber new number: 56)) equals: parser expression.! !

BBParserStackTest subclass: #BBP1Plus2Div3Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:17'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: nil equals: parser expression.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:18'!
testStep1

	parser sourceString: '('.
	parser run.
	self assert: (BBParenthesis new) equals: parser expression.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:34'!
testStep2

	parser sourceString: '(1'.
	parser run.
	self assert: (BBParenthesis inner: (BBNumber number: 1)) equals: parser expression.
	self assert: parser expression isParenthesisOpened.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:12'!
testStep3

	parser sourceString: '(1+'.
	parser run.
	self assert: (BBParenthesis inner: (BBAdd new left: (BBNumber new number: 1))) equals: parser expression.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:14'!
testStep4

	parser sourceString: '(1+2'.
	parser run.
	self assert: (BBParenthesis inner: (BBAdd left: (BBNumber new number: 1) right: (BBNumber new number: 2))) equals: parser expression! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:18'!
testStep5

	parser sourceString: '(1+2)'.
	parser run.
	self assert: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2))) equals: parser expression.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:19'!
testStep6

	parser sourceString: '(1+2)/'.
	parser run.
	self assert: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2)))) equals: parser expression.! !

!BBP1Plus2Div3Test methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:19'!
testStep7

	parser sourceString: '(1+2)/3'.
	parser run.
	self assert: (BBDivide new left: (BBParenthesis new inner: (BBAdd new left: (BBNumber new number: 1); right: (BBNumber new number: 2))); right: (BBNumber new number: 3)) equals: parser expression.! !

!BBParserStackTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:40'!
setUp

	parser := BlackBoxParser new.
	
	expectedRpnCode := OrderedCollection new.! !

BBParserStackTest subclass: #BBPrecedenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:19'!
testAddAndSubtractAreTie1

	parser sourceString: '1+2-3'.
	parser run.
	self assert: (BBSubtract left: (BBAdd left: (BBNumber number:1) right: (BBNumber number:2)) right: (BBNumber number: 3)) equals: parser expression! !

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:19'!
testAddAndSubtractAreTie2

	parser sourceString: '1-2+3'.
	parser run.
	self assert: (BBAdd left: (BBSubtract left:(BBNumber number: 1) right: (BBNumber number: 2)) right: (BBNumber number: 3)) equals: parser expression! !

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:43'!
testDivideBeatsAdd

	parser sourceString: '1+2/3'.
	parser run.
	self assert: (BBAdd new left: (BBNumber new number: 1); right: (BBDivide new left: (BBNumber new number: 2); right: (BBNumber new number: 3))) equals: parser expression! !

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:47'!
testDivideBeatsSubtract

	parser sourceString: '1-2/3'.
	parser run.
	self assert: (BBSubtract new left: (BBNumber new number: 1); right: (BBDivide new left: (BBNumber new number: 2); right: (BBNumber new number: 3))) equals: parser expression! !

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:20'!
testMultiplyAndDivideAreTie1

	parser sourceString: '1*2/3'.
	parser run.
	self assert: (BBDivide left: (BBMultiply left: (BBNumber number: 1) right: (BBNumber number: 2)) right: (BBNumber number: 3)) equals: parser expression! !

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:20'!
testMultiplyAndDivideAreTie2

	parser sourceString: '1/2*3'.
	parser run.
	self assert: (BBMultiply left: (BBDivide left: (BBNumber number: 1) right: (BBNumber number: 2)) right: (BBNumber number: 3)) equals: parser expression! !

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:21'!
testMultiplyBeatsAdd

	parser sourceString: '1+2*3'.
	parser run.
	self assert: (BBAdd new left: (BBNumber new number: 1); right: (BBMultiply new left: (BBNumber new number: 2); right: (BBNumber new number: 3))) equals: parser expression! !

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:27'!
testMultiplyBeatsSubtract

	parser sourceString: '1-2*3'.
	parser run.
	self assert: (BBSubtract new left: (BBNumber new number: 1); right: (BBMultiply new left: (BBNumber new number: 2); right: (BBNumber new number: 3))) equals: parser expression! !

!BBPrecedenceTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:12'!
testParenthesisBeatsMultiply

	parser sourceString: '1*(2+3)'.
	parser run.
	self assert: (BBMultiply left: (BBNumber number:1) right: (BBParenthesis inner: (BBAdd left: (BBNumber number: 2) right: (BBNumber number: 3)))) equals: parser expression! !

BBParserStackTest subclass: #BinaryExpressionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!BinaryExpressionTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:22'!
testAdd

	parser sourceString: '342+95'.
	parser run.
	self assert: (BBAdd new left: (BBNumber new number:342); right: (BBNumber new number:95)) equals: parser expression.! !

!BinaryExpressionTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:27'!
testDivide

	parser sourceString: '2/6'.
	parser run.
	self assert: (BBDivide new left: (BBNumber new number:2); right: (BBNumber new number:6)) equals: parser expression.! !

!BinaryExpressionTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:28'!
testMultiply

	parser sourceString: '2*6'.
	parser run.
	self assert: (BBMultiply new left: (BBNumber new number:2); right: (BBNumber new number:6)) equals: parser expression.! !

!BinaryExpressionTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:28'!
testSubtract

	parser sourceString: '66-8'.
	parser run.
	self assert: (BBSubtract new left: (BBNumber new number:66); right: (BBNumber new number:8)) equals: parser expression.! !

BBParserStackTest subclass: #DeepParenthesisParseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:29'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: nil equals: parser expression.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:29'!
testStep1

	parser sourceString: '('.
	parser run.
	self assert: (BBParenthesis new) equals: parser expression.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:07'!
testStep2

	parser sourceString: '(('.
	parser run.
	self assert: (BBParenthesis inner: (BBParenthesis new)) equals: parser expression.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:09'!
testStep3

	parser sourceString: '((('.
	parser run.
	self assert: (BBParenthesis inner: (BBParenthesis inner: (BBParenthesis new))) equals: parser expression.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:13'!
testStep4

	parser sourceString: '(((7'.
	parser run.
	self assert: (BBParenthesis inner: (BBParenthesis inner: (BBParenthesis inner: (BBNumber number: 7)))) equals: parser expression.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:22'!
testStep5

	parser sourceString: '(((7)'.
	parser run.
	self assert: (BBParenthesis inner: (BBParenthesis inner: (BBParenthesis inner: (BBNumber number: 7)))) equals: parser expression.
	self assert: parser expression isParenthesisOpened.
	self assert: parser expression inner isParenthesisOpened.
	self assert: parser expression inner inner isParenthesisClosed.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:23'!
testStep6

	parser sourceString: '(((7))'.
	parser run.
	self assert: (BBParenthesis inner: (BBParenthesis inner: (BBParenthesis inner: (BBNumber number: 7)))) equals: parser expression.
	self assert: parser expression isParenthesisOpened.
	self assert: parser expression inner isParenthesisClosed.
	self assert: parser expression inner inner isParenthesisClosed.! !

!DeepParenthesisParseTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:23'!
testStep7

	parser sourceString: '(((7)))'.
	parser run.
	self assert: (BBParenthesis inner: (BBParenthesis inner: (BBParenthesis inner: (BBNumber number: 7)))) equals: parser expression.
	self assert: parser expression isParenthesisClosed.
	self assert: parser expression inner isParenthesisClosed.
	self assert: parser expression inner inner isParenthesisClosed.! !

BBParserStackTest subclass: #NumberBlackBoxParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-test'!

!NumberBlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:30'!
testStep0

	parser sourceString: ''.
	parser run.
	self assert: nil equals: parser expression.! !

!NumberBlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:29'!
testStep1

	parser sourceString: '1'.
	parser run.
	self assert: (BBNumber new number: 1) equals: parser expression.! !

!NumberBlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:30'!
testStep2

	parser sourceString: '12'.
	parser run.
	self assert: (BBNumber new number: 12) equals: parser expression.! !

!NumberBlackBoxParserTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:31'!
testStep3

	parser sourceString: '123'.
	parser run.
	self assert: (BBNumber new number: 123) equals: parser expression.! !

Object subclass: #BBExpression
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBExpression class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

BBExpression subclass: #BBBinaryExpression
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

BBBinaryExpression subclass: #BBAdd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBAdd classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:06'!
isStrongerPrecedenceThanNumber

	^false! !

!BBAdd classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:06'!
isStrongerPrecedenceThanSubtract

	^false! !

!BBAdd classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:44'!
precedence

	^20! !

!BBAdd classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/13/2012 11:51'!
symbolicCharacter

	^$+! !

!BBBinaryExpression classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/13/2012 18:13'!
left: aBBNumber right: aBBNumber2 

	^self new left: aBBNumber ; right: aBBNumber2! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:12'!
gettersForEquality
	
	^#(left right)! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:15'!
isParenthesisClosed

	^left isParenthesisClosed and: [right isParenthesisClosed]! !

!BBBinaryExpression methodsFor: 'accessing' stamp: 'hjo 8/11/2012 21:15'!
left

	^left! !

!BBBinaryExpression methodsFor: 'accessing' stamp: 'hjo 8/11/2012 16:54'!
left: aBBNumber 

	left := aBBNumber! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:51'!
pushDivision

	^self class precedence < BBDivide precedence
		ifTrue: [right := BBDivide new left: right. self]
		ifFalse: [BBDivide new left: self ]! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:59'!
pushLeastDigit: aCharacter 

	right isNil 
		ifTrue: [ right := BBNumber number: aCharacter digitValue ]
		ifFalse: [ right pushLeastDigit: aCharacter ]
	! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:51'!
pushMultiplication

	^self class precedence < BBMultiply precedence
		ifTrue: [right := BBMultiply new left: right. self]
		ifFalse: [BBMultiply new left: self ]! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:52'!
pushSubtraction

	^self class precedence < BBSubtract precedence
		ifTrue: [right := BBSubtract left: right. self]
		ifFalse: [BBSubtract new left: self ]! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:15'!
right

	^right! !

!BBBinaryExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:55'!
right: aBBNumber 

	right := aBBNumber! !

BBBinaryExpression subclass: #BBDivide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 10:45'!
isNotWeakerPrecedenceThanAdd

	^true! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 11:33'!
isNotWeakerPrecedenceThanMultiply

	^true! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 10:42'!
isNotWeakerPrecedenceThanNumber

	^false! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 10:44'!
isNotWeakerPrecedenceThanParenthesis

	^false! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 10:46'!
isNotWeakerPrecedenceThanSubtract

	^true! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:02'!
isStrongerPrecedenceThanAdd

	^true! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:03'!
isStrongerPrecedenceThanMultiply

	^false! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:03'!
isStrongerPrecedenceThanNumber

	^false! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:02'!
isStrongerPrecedenceThanSubtract

	^true! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:44'!
precedence

	^60! !

!BBDivide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/13/2012 11:51'!
symbolicCharacter
	^$/! !

BBBinaryExpression subclass: #BBMultiply
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 11:33'!
isNotWeakerPrecedenceThanAdd

	^true! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 10:43'!
isNotWeakerPrecedenceThanDivide

	^true! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 11:32'!
isNotWeakerPrecedenceThanNumber

	^false! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 11:33'!
isNotWeakerPrecedenceThanSubtract

	^true! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:04'!
isStrongerPrecedenceThanAdd

	^true! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:04'!
isStrongerPrecedenceThanDivide

	^false! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:03'!
isStrongerPrecedenceThanNumber

	^false! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:05'!
isStrongerPrecedenceThanSubtract

	^true! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:44'!
precedence

	^60! !

!BBMultiply classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/13/2012 11:51'!
symbolicCharacter
	^$*! !

!BBMultiply methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:11'!
closeInnerMostParenthesis

	right closeInnerMostParenthesis! !

!BBMultiply methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:10'!
pushAddition

	^right isNil
		ifTrue: [self class precedence < BBAdd precedence ifTrue: [right := BBAdd new left: right. self] ifFalse: [BBAdd new left: self ]]
		ifFalse: [right pushAddition. self]
! !

!BBMultiply methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:34'!
pushParenthesis

	right := BBParenthesis new! !

BBBinaryExpression subclass: #BBSubtract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBSubtract classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:07'!
isStrongerPrecedenceThanAdd

	^false! !

!BBSubtract classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:05'!
isStrongerPrecedenceThanNumber

	^false! !

!BBSubtract classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:45'!
precedence

	^20! !

!BBSubtract classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/13/2012 11:51'!
symbolicCharacter
	^$-! !

!BBSubtract methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:57'!
pushAddition

	^self class precedence < BBAdd precedence
		ifTrue: [right := BBAdd new left: right. self]
		ifFalse: [BBAdd new left: self ]! !

!BBExpression classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:41'!
precedence

	^50! !

BBExpression subclass: #BBNumber
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBNumber classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/13/2012 18:12'!
number: aSmallInteger 

	^self new number: aSmallInteger! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:10'!
gettersForEquality

	^#(number)! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:20'!
isParenthesisClosed

	^true! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:10'!
number

	^number! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:54'!
number: aNumber 

	number := aNumber! !

!BBNumber methodsFor: 'binary expression' stamp: 'hjo 8/14/2012 14:22'!
pushAddition

	^BBAdd new left: self! !

!BBNumber methodsFor: 'binary expression' stamp: 'hjo 8/14/2012 14:25'!
pushDivision

	^BBDivide new left: self! !

!BBNumber methodsFor: 'as yet unclassified' stamp: 'hjo 8/13/2012 11:47'!
pushLeastDigit: aCharacter 

	number := number * 10 + aCharacter digitValue! !

!BBNumber methodsFor: 'binary expression' stamp: 'hjo 8/14/2012 14:27'!
pushMultiplication

	^BBMultiply new left: self! !

!BBNumber methodsFor: 'binary expression' stamp: 'hjo 8/14/2012 14:29'!
pushSubtraction

	^BBSubtract new left: self! !

BBExpression subclass: #BBParenthesis
	instanceVariableNames: 'inner closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBParenthesis classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:08'!
inner: aBBParenthesis 

	^self new inner: aBBParenthesis  ! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:20'!
beParenthesisClosed

	closed := true.! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:19'!
closeInnerMostParenthesis

	inner isParenthesisClosed
		ifTrue: [self beParenthesisClosed]
		ifFalse: [inner closeInnerMostParenthesis]! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:54'!
gettersForEquality

	^#(inner)! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:55'!
inner 

	^inner! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 16:55'!
inner: aBBAdd 

	inner := aBBAdd! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:19'!
isParenthesisClosed

	^closed = true! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:22'!
isParenthesisOpened

	^self isParenthesisClosed not! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:21'!
pushAddition

	^self isParenthesisClosed
		ifTrue: [BBAdd new left: self]
		ifFalse: [inner := BBAdd new left: inner. self]! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 14:21'!
pushDivision

	^self isParenthesisClosed
		ifTrue: [BBDivide new left: self]
		ifFalse: [inner := BBDivide new left: inner. self]! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:11'!
pushLeastDigit: aCharacter 

	inner isNil 
		ifTrue: [inner := BBNumber number:  aCharacter digitValue]
	 	ifFalse: [inner pushLeastDigit: aCharacter]	! !

!BBParenthesis methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:35'!
pushParenthesis

	inner isNil
		ifTrue: [inner := BBParenthesis new]
		ifFalse: [inner pushParenthesis  ]! !

Object subclass: #BBExpressionHolder
	instanceVariableNames: 'expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser-Expression'!

!BBExpressionHolder methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:16'!
closeInnerMostParenthesis

	expression closeInnerMostParenthesis.! !

!BBExpressionHolder methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:59'!
expression

	^ expression! !

!BBExpressionHolder methodsFor: 'binary expression' stamp: 'hjo 8/14/2012 14:24'!
pushAddition

	expression := expression isNil
		ifTrue: [self error: 'cannot add something to nothing']
		ifFalse: [expression pushAddition]! !

!BBExpressionHolder methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:56'!
pushDigit: aCharacter 

	expression isNil ifTrue: [expression := BBNumber number: aCharacter digitValue. ^self].
	expression pushLeastDigit: aCharacter.  ! !

!BBExpressionHolder methodsFor: 'binary expression' stamp: 'hjo 8/14/2012 14:25'!
pushDivision

	expression := expression isNil
		ifTrue: [self error: 'cannot divide something to nothing']
		ifFalse: [expression pushDivision]! !

!BBExpressionHolder methodsFor: 'binary expression' stamp: 'hjo 8/14/2012 14:26'!
pushMultiplication

	expression := expression isNil
		ifTrue: [self error: 'cannot multiply something to nothing']
		ifFalse: [expression pushMultiplication]! !

!BBExpressionHolder methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:33'!
pushParenthesis

	expression isNil
		ifTrue: [ expression := BBParenthesis new ]
		ifFalse: [ expression pushParenthesis ] ! !

!BBExpressionHolder methodsFor: 'binary expression' stamp: 'hjo 8/14/2012 14:28'!
pushSubtraction

	expression := expression isNil
		ifTrue: [self error: 'cannot subtract something to nothing']
		ifFalse: [expression pushSubtraction]! !

Object subclass: #BlackBoxParser
	instanceVariableNames: 'stream parsingDictionary expressionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlackBoxParser'!

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 13:08'!
expression

	^expressionHolder expression! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 12:53'!
initialize

	super initialize.
	expressionHolder := BBExpressionHolder new.
	self makeParsingDictionary.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/14/2012 15:32'!
makeParsingDictionary

	parsingDictionary := Dictionary new.
	
	parsingDictionary 
		at: $( put:  [expressionHolder pushParenthesis];
		at: $) put:  [expressionHolder closeInnerMostParenthesis ].

	'1234567890' do: [:digit|
		parsingDictionary at: digit put: [ expressionHolder pushDigit: digit ] ].

	parsingDictionary at: $+ put: [expressionHolder pushAddition].
	parsingDictionary at: $- put: [expressionHolder pushSubtraction].
	parsingDictionary at: $* put: [expressionHolder pushMultiplication].
	parsingDictionary at: $/ put: [expressionHolder pushDivision].! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 21:07'!
run

	[self step] whileTrue.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/11/2012 18:41'!
sourceString: aString 

	stream := aString readStream.! !

!BlackBoxParser methodsFor: 'as yet unclassified' stamp: 'hjo 8/12/2012 18:18'!
step

	stream atEnd ifTrue: [^false].
	(parsingDictionary at: stream next) value.
	^true! !
